package Kirjalista;

import java.util.ArrayList;

import tietorakenne.LinkattuLista;

/**
 * Genren ja kirjan välinen relaatio
 * - pitää kirjaa liimatuista genreistä ja kirjoista
 * - palauttaa kirjojen id:t genren id:n perusteella
 * - palauttaa genrejen id:t kirjan id:n perusteella
 * - lukee ja kirjoittaa tiedostoon
 */
public class GenreRelaatio {
    private LinkattuLista<KirjanGenre> alkiot = new LinkattuLista<KirjanGenre>();
    
    /**
     * Lisää listaan alkion
     * @param alkio Alkio, joka lisätään listaan
     */
    public void lisaa(KirjanGenre alkio) {
        alkiot.lisaa(alkio);
    }
    
    
    /**
     * Palauttaa ArrayListin kirjojen id:istä, joilla on tietty genreid
     * esim. palauttaa kaikkien kirjojen id:t, joiden genre on fantasia
     * @param genreId Genren id, jonka perusteella haetaan kirjojen id:itä
     * @return Kaikkien niiden kirjojen id:t, joiden genren id on genreId 
     * TODO testit
     * <pre name="test">
     * GenreRelaatio gr = new GenreRelaatio();
	 * gr.lisaa(new KirjanGenre(1, 2));
	 * int[] t = gr.haeKirjat(2);  
	 * t[0] === 1;
	 * TODO lisää testejä
	 * </pre>
     */
    public ArrayList<Integer> haeKirjat(int genreId) {
        //if (alkiot.length() <= 0) throw new IndexOutOfBoundsException();        
        ArrayList<Integer> kirjojenIdt = new ArrayList<Integer>();
        
        alkiot.iter = alkiot.getEka();
        
        for (int i = 0; i < alkiot.length(); i++) {
            KirjanGenre alkio = alkiot.iter.getSisalto();
            if (alkio.getGenreId() == genreId) {
                kirjojenIdt.add(alkio.getGenreId());
            }
            alkiot.iter = alkiot.iter.getNext();
        }
        
        return kirjojenIdt;
    }
    
    
    /**
     * Palauttaa ArrayListin genrejen id:istä, joilla on tietty kirjaid
     * eli toisin sanoen palauttaa tietyn kirjan kaikkien genrejen id:t
     * @param kirjaId Kirjan id, jonka perusteella haetaan genrejen id:itä
     * @return Kaikkien niiden genrejen id:t, joiden kirjan id on kirjaId 
     * TODO testit
     */
    public ArrayList<Integer> haeGenret(int kirjaId) {
        //if (alkiot.length() <= 0) throw new IndexOutOfBoundsException(); ??? tämä ei mahdollista
        ArrayList<Integer> genrejenIdt = new ArrayList<Integer>();
        
        alkiot.iter = alkiot.getEka();
        
        for (int i = 0; i < alkiot.length(); i++) {
            KirjanGenre alkio = alkiot.iter.getSisalto();
            if (alkio.getKirjaId() == kirjaId) {
                genrejenIdt.add(alkio.getGenreId());
            }
            alkiot.iter = alkiot.iter.getNext();
        }
        
        return genrejenIdt;
    }
    
    
    /**
     * Poistaa alkion annetussa indeksipaikassa
     * @param indeksi Indeksipaikka, josta alkio poistetaan
     */
    public void poista(int indeksi) {
        alkiot.poista(indeksi);
    }
}
