package Kirjalista;

import java.util.ArrayList;
import java.util.NoSuchElementException;

/**
 * Monikkoluokka genreille
 * - Sisältää listan genreistä
 * - Lisää ja poistaa kirjoja
 * - Lukee ja kirjoittaa tiedostoon
 * - Etsii ja lajittelee
 */
public class Genret {
    private ArrayList<Genre> alkiot = new ArrayList<Genre>();
    
    
    /**
     * Lisää genren listaan, jos samannimistä genreä ei ole olemassa
     * @param genre Lisättävä genre
     */
    public void lisaa(Genre genre) {
        if (onOlemassa(genre.getNimi())) {
            genre.setId(haeIdNimella(genre.getNimi()));
            return;
        }
        genre.rekisteroi();
        alkiot.add(genre);
    }
    
    
    private int haeIdNimella(String nimi) {
        for (int i = 0; i < alkiot.size(); i++) {
            if (alkiot.get(i).getNimi() == nimi) return alkiot.get(i).getId();
        }
        return -1;
    }


    /**
     * Poistaa genren annetulla id:llä
     * @param id Id, jonka perusteella genre poistetaan
     * TODO testit
     */
    public void poista(int id) {
        for (int i = 0; i < alkiot.size(); i++) {
            if (alkiot.get(i).getId() == id) {
                alkiot.remove(i);
                return;
            }
        }
        throw new NoSuchElementException("Genreä id:llä " + id + " ei löydy.");
    }
    
    
    /**
     * Tarkistaa, onko tietyn nimistä genreä olemassa
     * @param nimi Genren nimi
     * @return True, jos genre on olemassa
     */
    public boolean onOlemassa(String nimi) {
        for (int i = 0; i < alkiot.size(); i++) {
            if (alkiot.get(i).getNimi() == nimi) {
                return true;
            }
        }
        return false;
    }
    
    
    /**
     * Hakee genren nimen id:n perusteella
     * @param id haettavan genren id
     * @return Viite genreen halutulla id:llä
     * TODO testit
     */
    public Genre hae(int id) {
        for (int i = 0; i < alkiot.size(); i++) {
            if (alkiot.get(i).getId() == id) return alkiot.get(i);
        }
        
        throw new NoSuchElementException("Genreä id:llä " + id + " ei löydy!");
    }
    
}
