package Kirjalista;

import java.util.NoSuchElementException;

/**
 * Monikkoluokka kirjoille.
 * - Sisältää taulukon kirjoista
 * - Lisää ja poistaa kirjoja
 * - Lukee ja kirjoittaa tiedostoon (sitten joskus)
 * - Etsii ja lajittelee (sitten joskus)
 */
public class Kirjat {
    private int maxLkm = 8;
    private int lkm = 0;
    private Kirja[] alkiot = new Kirja[maxLkm];
    
    
    /**
     * @param kirja Lisättävä kirja
     * @throws SailoException Heittää, jos lisääminen ei onnistu
     */
    public void lisaa(Kirja kirja) throws SailoException {
        if (this.lkm >= this.alkiot.length) throw new SailoException("Liikaa alkioita");
        this.alkiot[this.lkm] = kirja;
        kirja.rekisteroi();
        this.lkm++;
    }
    
    
    /**
     * Poistaa kirjan annetulla id:llä
     * @param id Poistettavan kirjan id
     * @throws NoSuchElementException Jos id:tä vastaavaa kirjaa ei löydy
     * TODO testit
     */
    public void poista(int id) throws NoSuchElementException {
        for (int i = 0; i < alkiot.length; i++) {
            if (alkiot[i].getId() == id) {
                for (int j = i; j < alkiot.length - 1; j++) {
                    alkiot[j] = alkiot[j + 1];
                }
                alkiot[alkiot.length] = null;
                this.lkm--;
                return;
            }
        }
        throw new NoSuchElementException("Kirjaa id:llä " + id + " ei löydy.");
    }

    /**
     * Hakee kirjan id:n perusteella
     * @param id Halutun kirjan id
     * @return Viite kirjaan halutulla id:llä
     * @throws NoSuchElementException
     * TODO testit
     */
    public Kirja hae(int id) throws NoSuchElementException {
        
        for (int i = 0; i < alkiot.length; i++) {
            if (alkiot[i].getId() == id) return alkiot[i];
        }
        
        throw new NoSuchElementException("Kirjaa id:llä " + id + " ei löytynyt.");
    }

    
    /**
     * Hakee kirjan indeksin perusteella
     * @param ind Indeksipaikka, josta kirja haetaan
     * @return Kirja annetussa indeksipaikassa
     */
    public Kirja haeIndeksilla(int ind) {
        if (ind < 0 || ind >= this.lkm) throw new NullPointerException("Laiton indeksi");
        return alkiot[ind];
    }
    
    
    /**
     * Palauttaa kirjojen lukumäärän
     * @return kirjojen lukumäärä
     */
    public int getLkm() {
        return this.lkm;
    }

}
