package fxKirjalista;

import Kirjalista.Genre;
import Kirjalista.Kirja;
import Kirjalista.Kirjasto;
import Kirjalista.SailoException;
import fi.jyu.mit.fxgui.ComboBoxChooser;
import javafx.fxml.FXML;
import javafx.scene.control.TextField;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;


/**
 * Kirjan liäämisikkunan käsittelijä
 */
public class LisaaController {

  
    @FXML private ComboBoxChooser<?> comboboxGenre;
    @FXML private TextField textKirjailija;
    @FXML private TextField textNimi;
    @FXML private TextField textSarja;
    @FXML private TextField textSivu;
    @FXML private TextField textVuosi;

    private Kirjasto kirjasto;
    
    private KirjalistaGUIController isanta;
    
    @FXML void handleLisaaOK() {
        uusiKirja();
        //Dialogs.showMessageDialog("Vielä ei osata lisätä");
        ModalController.closeStage(textNimi);
    }


    @FXML void handleMuokkaaOK() {
        Dialogs.showMessageDialog("Vielä ei osata muokata");
        ModalController.closeStage(textNimi);
    }

    
    @FXML void handlePoista() {
        KirjalistaGUIController.poistoVahvistus();
        ModalController.closeStage(textNimi);

    }
    
    
    /**
     * Asettaa controllerille viitteen kirjasto-olioon
     * @param kirjasto Kirjasto-luokan olio, johon viite asetetaan
     */
    public void setKirjasto(Kirjasto kirjasto) {
        this.kirjasto = kirjasto;
    }
    
    
    
    /**
     * Asettaa olion "isännäksi" kirjalistan pääikkunan kontrollerin, jotta
     * keskustelu kontrollerien välillä helpompaa
     * @param isanta Pääikkunan kontrolleri
     */
    public void setIsanta(KirjalistaGUIController isanta) {
        this.isanta = isanta;
    }
    
    
    /**
     * Luo kirjan ja antaa sille id:n. Pyrkii lisäämään sen kirjat-olion
     * taulukkoon ja antaa virheen, jos ei onnistu.
     */
    protected void uusiKirja() {
        /* Lopullisessa versiossa käyttöliittymästä tulisi 
         * tekstiä, josta parsetaan kirjan tiedot ja tekstiä, josta
         * parsetaan genret. 
         */
        
        
        Kirja uusi = new Kirja();
        Genre genre1 = new Genre();
        Genre genre2 = new Genre();
        Genre genre3 = new Genre();
        // uusi.parse( käyttöliittymästä tullut teksti );
        // 
        // String[] genreStr = teksti.split("|");
        // Genre[] genret = new Genre[genreStr.length];
        // for (int i = 0; i < genreStr.length; i++) {
        //     genre g = new Genre();
        //     genret[i] = g.parse(genreStr[i]);
        // }
        // kirjasto.lisaaGenre(genret);
        // 
        // kirjasto.lisaaGenreRelaatio(uusi, genret);
        //
        // ^^^^ näin sitten toimivassa ohjelmassa ^^^^
        

        
        uusi.esimerkkiKirja();
        genre1.esimerkkiGenre();
        genre2.esimerkkiGenre();
        genre3.esimerkkiGenre();
        
        
        Genre[] g = {genre1, genre2, genre3};
        
        kirjasto.lisaaGenre(g);
        
        try {
            kirjasto.lisaaKirja(uusi);
        } catch (SailoException e) {
            Dialogs.showMessageDialog("Ongelma " + e.getMessage());
            return;
        }
        
        kirjasto.lisaaGenreRelaatio(uusi, g);
        
        isanta.hae(uusi.getId());
    
    }
    
}
